#!/bin/sh
# $Id: 8.mkiso.sh,v 1.13 2004/02/04 20:19:36 dave Exp $

. ./config.sh

# Filesystems to backup are: /etc, /usr/local/etc, /root, /dev
MD5_DIR=$FREESBIEBASEDIR/usr/local/
MD5_ETC=etc.md5
#MD5_USRLOCALETC=usr.local.etc.md5
MD5_ROOT=root.md5

#Removed unwanted files
cd $FREESBIEBASEDIR
rm -f etc/X11/XF86Config
rm -f etc/resolv.conf

rm -f root/.choose
rm -f root/.first_time
rm -f root/.xfirst_time

#
# Run baby run...
#
tar czfp mfs/etc.tgz etc
if [ "$RELEASE" != "5" ]; then 
    tar czfp mfs/dev.tgz dev; 
fi
tar czfp mfs/root.tgz root
#tar czfp mfs/local_etc.tgz usr/local/etc

#
# Creating md5 files
#
echo "Calculating MD5..."

[ -e $MD5_DIR/$MD5_ETC ] && rm $MD5_DIR/$MD5_ETC
for i in `find etc -type f`
do
	md5 $i | awk '{print substr($0,5,length($0))}' >> $MD5_DIR/$MD5_ETC
done

#[ -e $MD5_DIR/$MD5_USRLOCALETC ] && rm $MD5_DIR/$MD5_USRLOCALETC
#for i in `find usr/local/etc -type f`
#do
#	md5 $i | awk '{print substr($0,5,length($0))}' >> $MD5_DIR/$MD5_USRLOCALETC
#done

[ -e $MD5_DIR/$MD5_ROOT ] && rm $MD5_DIR/$MD5_ROOT
for i in `find root -type f`
do
	md5 $i | awk '{print substr($0,5,length($0))}' >> $MD5_DIR/$MD5_ROOT
done

#[ -e $MD5_DIR/$MD5_VAR ] && rm $MD5_DIR/$MD5_VAR
#for i in `find var -type f`
#do
#	md5 $i | awk '{print substr($0,5,length($0))}' >> $MD5_DIR/$MD5_VAR
#done

cp $LOCALDIR/files/boot.catalog $FREESBIEBASEDIR/boot

/usr/local/bin/mkisofs -b boot/cdboot -no-emul-boot -c boot/boot.catalog -R -J -V FreeSBIE -o $PATHISO .

